/* armorshop.c */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <curses.h>
#include "basics.h"
#include "cleric.h"
#include "magicuser.h"
#include "fighter.h"
#include "thief.h"


int
main(int argc, char *argv[]){
	FILE *clericfp, *clericfpout;
	FILE *fighterfp, *fighterfpout;
	FILE *magicuserfp;
	FILE *thieffp;
	struct cleric *clericp;/* fighter thief magic user placeholders */
	struct magicuser* magicuserp;
	struct fighter* fighterp;
	struct thief* thiefp;
	armor *myshield;
	armor *myarmor;
	int done;
	char input[40];
	char ans;
	WINDOW *win;

	win=initscr();

	if(argc!=2)return 1;


	if((strcmp(argv[1], "fighter.bin"))==0){
		if((fighterfp = fopen(argv[1], "rb")) == NULL){
			wprintw(win, "file not found\n");
			wrefresh(win);
			return 2;
		}
		if(fighterp=malloc(sizeof(struct fighter))){
			if( (fread(fighterp, sizeof(struct fighter), 1, fighterfp)) ){
				if(feof(fighterfp)){
					 wprintw(win, "premature end of file.");
				}
			} 
		}
		fclose(fighterfp);
		wprintw(win, "Welcome to the armor shop %s\n", fighterp->stat.name);
		done=0;
		while(!done){
			wprintw(win, "armor:\n");
			if(fighterp->shield)myshield=armor_hop(fighterp->shield, win);
			if(fighterp->armor)myarmor=armor_hop(fighterp->armor, win);
			if(fighterp->shield){
				wprintw(win, "Trade shield in> ");
				wrefresh(win);
				wgetnstr(win, input, 40);
				if(strcmp(input, "trade")==0){
					fighterp->shield=0;
					fighterp->stat.ac+=1;
					fighterp->coin+=(myshield->cost-3);
					free(myshield);
				}
			}
			else {
				wprintw(win, "Buy shield> ");
				wrefresh(win);
				wgetnstr(win, input, 40);
				if(strcmp(input, "buy")==0){
					myshield=armor_hop(fighterp->shield, win);
					if(fighterp->coin>myshield->cost){ 
						fighterp->shield=myshield->tag;
						fighterp->coin-=(myshield->cost);
						fighterp->stat.ac-=1;
					}
				}
			}
			if(fighterp->armor){
				wprintw(win, "Trade armor in> ");
				wrefresh(win);
				wgetnstr(win, input, 40);
				if(strcmp(input, "trade")==0){
					if(fighterp->shield)fighterp->stat.ac=12+myshield->diff;
					else fighterp->stat.ac=12;
					fighterp->armor=0;
					fighterp->coin+=(myarmor->cost-5);
					free(myarmor);
				}
			} else {
				wprintw(win, "Buy armor [2-7]> ");
				wrefresh(win);
				wgetnstr(win, input, 40);
				ans=input[0];
				if(ans=='2'||ans=='3'||ans=='4'||ans=='5'||ans=='6'||ans=='7'){
					myarmor=armor_hop(atoi(input), win);
					if(fighterp->coin>myarmor->cost){
						fighterp->armor=myarmor->tag;
						if(fighterp->shield)fighterp->stat.ac=(myarmor->diff+myshield->diff);
						else fighterp->stat.ac=myarmor->diff;
						fighterp->coin-=myarmor->cost;
					}
					else {
						wprintw(win, "couldn't afford it\n");
						wrefresh(win);
					}
				}
			}
			wprintw(win, "quit shop> ");
			wrefresh(win);
			wgetnstr(win, input, 40);
			if(strcmp(input, "exit")==0)
				done=1;
		}
		if((fighterfpout = fopen(argv[1], "w+b")) == NULL){
			wprintw(win, "file not found\n");
			wrefresh(win);
			return 2;
		}
		if(fwrite(fighterp, sizeof(struct fighter), 1, fighterfpout)!= 1){
			wprintw(win, "File write error.\n");
			wrefresh(win);
		}
		free(myshield);
		free(myarmor);
		free(fighterp);
		fclose(fighterfp);
	}
	else if((strcmp(argv[1], "thief.bin"))==0){
		wprintw(win, "I am afraid your going to have to leave sir.\n");
	}
	else if((strcmp(argv[1], "cleric.bin"))==0){
		if((clericfp = fopen(argv[1], "rb")) == NULL){
			wprintw(win, "file not found\n");
			wrefresh(win);
			return 2;
		}
		if(clericp=malloc(sizeof(struct cleric))){
			if( (fread(clericp, sizeof(struct cleric), 1, clericfp)) ){
				if(feof(clericfp)) {
					wprintw(win, "premature end of file.");
					wrefresh(win);
				}
			}
		}
		fclose(clericfp);
		wprintw(win, "Welcome to the armor shop %s\n", clericp->stat.name);
		done=0;
		while(!done){
		wprintw(win, "armor:\n");
		wrefresh(win);
		if(clericp->shield)myshield=armor_hop(clericp->shield, win);
			if(clericp->armor)myarmor=armor_hop(clericp->armor, win);
			if(clericp->shield){
				wprintw(win, "Trade shield in> ");
				wgetnstr(win, input, 40);
				if(strcmp(input, "trade")==0){
					clericp->shield=0;
					clericp->stat.ac+=1;
					clericp->coin+=(myshield->cost-3);
					free(myshield);
				}
			}
			else {
				wprintw(win, "Buy shield> ", 40);
				wrefresh(win);
				wgetnstr(win, input, 40);
				if(strcmp(input, "buy")==0){
					myshield=armor_hop(clericp->shield, win);
					if(clericp->coin>myshield->cost){ 
						clericp->shield=myshield->tag;
						clericp->coin-=(myshield->cost);
						clericp->stat.ac-=1;
					}
				}
			}
			if(clericp->armor){
				wprintw(win, "Trade armor in> ");
				wrefresh(win);
				wgetnstr(win, input, 40);
				if(strncmp(input, "trade", strlen(input))==0){
					if(clericp->shield)clericp->stat.ac=12+myshield->diff;
					else clericp->stat.ac=12;
					clericp->armor=0;
					clericp->coin+=(myarmor->cost-5);
					free(myarmor);
				}
			} else {
				wprintw(win, "Buy armor [2-7]> ");
				wgetnstr(win, input, 40);
				ans=input[0];
				if(ans=='2'||ans=='3'||ans=='4'||ans=='5'||ans=='6'||ans=='7'){
					myarmor=armor_hop(atoi(input), win);
					if(clericp->coin>myarmor->cost){
						clericp->armor=myarmor->tag;
						if(clericp->shield)clericp->stat.ac=(myarmor->diff+myshield->diff);
						else clericp->stat.ac=myarmor->diff;
						clericp->coin-=myarmor->cost;
					}
					else {
						wprintw(win, "couldn't afford it\n");
					}
					free(myarmor);
				}
			}
			wprintw(win, "quit shop> ");
			wrefresh(win);
			wgetnstr(win, input, 40);
			if(strncmp(input, "exit", strlen(input))==0)
				done=1;
		}
		if((clericfpout = fopen(argv[1], "wb")) == NULL){
			wprintw(win, "file not found\n");
			return 2;
		}
		if(fwrite(clericp, sizeof(struct cleric), 1, clericfpout)!= 1)
			wprintw(win, "File write error.\n");
		if(myshield)free(myshield);
		if(myarmor)free(myarmor);
		if(clericp)free(clericp);
		fclose(clericfp);
	}
	else if((strncmp(argv[1], "magicuser.bin", strlen(argv[1])))==0){
		if((magicuserfp = fopen(argv[1], "rb")) == NULL){
			wprintw(win, "file not found\n");
			return 2;
		}
		if(magicuserp=malloc(sizeof(struct magicuser))){
			if( (fread(magicuserp, sizeof(struct magicuser), 1, magicuserfp)) ){
				if(feof(magicuserfp)){
					wprintw(win, "premature end of file.");
					wrefresh(win);
				}
			}
		}
		free(magicuserp);
		fclose(magicuserfp);
		wprintw(win, "Please sir you should visit the guild.\n");
		wrefresh(win);
	}
	else {
		wprintw(win, "wrong file format\n");
		wrefresh(win);
		return 3;
	}
	free(win);
	free(win);
	free(win);
	return 0;
}
