#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <curses.h>
#include "basics.h"
#include "cleric.h"
#include "fighter.h"
#include "thief.h"
#include "magicuser.h"

void fighterreschedule(struct fighter*, long *);
void thiefreschedule(struct thief*, long*);
void clericreschedule(struct cleric*, long*);
void magicuserreschedule(struct magicuser*, long*);
float ran0(long*);

int
main(int argc, char *argv[]){
	struct cleric* clericp;/* fighter thief magic user placeholders */
	FILE *clericfpin;		/* a separate file pointer must be created per filename used */
	FILE *clericfpout;		/* a separate file pointer must be created per filename used */
	struct fighter* fighterp; /* it seems particularly when writing out an object */
	FILE *fighterfpin;
	FILE *fighterfpout;
	struct thief* thiefp;
	FILE *thieffpin;
	FILE *thieffpout;
	struct magicuser* magicuserp;
	FILE *magicuserfpin;
	FILE *magicuserfpout;
	armor *myshield;
	armor *myarmor;
	weap *myweapone;
	weap *myweaptwo;
	int done;
	char input[40];
	char ans;
	int i;
	long myseed;
	int changed;
	WINDOW *win;

	win=initscr();

	if(argc!=3)return 1;

	myseed=labs(atol(argv[2]));

	changed = 0;

	if((strcmp(argv[1], "fighter.bin"))==0){
		if((fighterfpin = fopen(argv[1], "rb")) == NULL){
			wprintw(win, "file not found\n");
			wrefresh(win);
			return 2;
		}
		if(fighterp=malloc(sizeof(struct fighter))){
			if( (fread(fighterp, sizeof(struct fighter), 1, fighterfpin)) ){
				if(feof(fighterfpin)) {
					wprintw(win, "premature end of file.");
					wrefresh(win);
				}
			}
		}
		fclose(fighterfpin);
		wprintw(win, "%s\n", fighterp->stat.name);
		if(fighterp->stat.ldr)wprintw(win, "deceased heroe\n");
		wprintw(win, "level: %d\n", fighterp->stat.level);
		wprintw(win, "points: %d\n", fighterp->stat.points);
		wprintw(win, "target to reach level %d: %d\n", fighterp->stat.level+1, fighterp->stat.target);
		wrefresh(win);
		if(!(fighterp->stat.ldr)){
			if(fighterp->stat.points> fighterp->stat.target){
				wprintw(win, "Rescheduling is necessary\n");
				done=0;
				while(!done){
					wprintw(win, "> ");
					wrefresh(win);
					wgetnstr(win, input, 40);
					if(strcmp(input, "reschedule")==0){
						fighterreschedule(fighterp, &myseed);
						changed=1;
						return 0;
					}
					if(strcmp(input, "exit")==0){
						done=1;
					}
				}
			} else if(fighterp->stat.level==2){
				wprintw(win, "check level per hall use\n");
				wrefresh(win);
			}
			wprintw(win, "armor:\n"); /* local copies of items hoppers */
			wrefresh(win);
			if(fighterp->shield){
				myshield=armor_hop(fighterp->shield, win);
				free(myshield);
			}
			if(fighterp->armor>0){
				myarmor=armor_hop(fighterp->armor, win);
				free(myarmor);
			}
			wprintw(win, "weapons:\n");
			wrefresh(win);
			if(fighterp->weaponone>0){
				myweapone=weap_hop(fighterp->weaponone, win);
				free(myweapone);
			}
			if(fighterp->weapontwo>0){
				myweaptwo=weap_hop(fighterp->weapontwo, win);
				free(myweaptwo);
			}
			wprintw(win, "str: %d %d\n", fighterp->stat.str, fighterp->stat.strbon);
			wprintw(win, "int: %d %d\n", fighterp->stat.intel, fighterp->stat.intelbon);
			wprintw(win, "wis: %d %d\n", fighterp->stat.wis, fighterp->stat.wisbon);
			wprintw(win, "dex: %d %d\n", fighterp->stat.dex, fighterp->stat.dexbon);
			wprintw(win, "con: %d %d\n", fighterp->stat.con, fighterp->stat.conbon);
			wprintw(win, "cha: %d %d\n", fighterp->stat.cha, fighterp->stat.chabon);
			wprintw(win, "%s\n", fighterp->stat.prsnlty);
			wprintw(win, "%s\n", fighterp->stat.bckgrnd);
			wprintw(win, "mechanics:\n");
			wprintw(win, "MAXHP: %d HP: %d AC: %d thaco: %d\n", fighterp->stat.maxhp, fighterp->stat.curhp, fighterp->stat.ac, fighterp->stat.thaco);
			wrefresh(win);
			if(fighterp->stat.maxhp>fighterp->stat.curhp){
				changed=1;
				fighterp->stat.curhp=fighterp->stat.maxhp;
				wprintw(win, "Recovery time awarded. MAXHP: %d HP: %d\n", fighterp->stat.maxhp, fighterp->stat.curhp);
			}
			wprintw(win, "gold pieces: %d\n", fighterp->coin);
			wrefresh(win);
			if(changed){
				remove("fighter.bin");
				if((fighterfpout=fopen(argv[1], "wb")) == NULL){
					wprintw(win, "file creation failed\n");
					return 255;
				}
				if ( (fwrite(fighterp, sizeof(struct fighter), 1, fighterfpout)) != 1) {
					wprintw(win, "writing out updated character object failed\n");
				}
				free(fighterp);
				fclose(fighterfpout);
			}
			wrefresh(win);
		}
	}
	else if((strcmp(argv[1], "thief.bin"))==0){
		if((thieffpin = fopen(argv[1], "rb")) == NULL){
			wprintw(win, "file not opened\n");
			return 3;
		}
		if(thiefp=malloc(sizeof(struct thief))){
			if( (fread(thiefp, sizeof(struct thief), 1, thieffpin)) ){
				if(feof(thieffpin)) wprintw(win, "premature end of file.");
			}
		}
		fclose(thieffpin);
		wprintw(win, "%s\n", thiefp->stat.name);
		wprintw(win, "level: %d\n", thiefp->stat.level);
		wprintw(win, "points: %d\n", thiefp->stat.points);
		wprintw(win, "target to reach level %d: %d\n", thiefp->stat.level+1, thiefp->stat.points);
		wrefresh(win);
		if(!(thiefp->stat.ldr)){
			if(thiefp->stat.points>thiefp->stat.target){
				wprintw(win, "rescheduling is required.\n");
				done=0;
				while(!done){
					wprintw(win, "> ");
					wgetnstr(win, input, 40);
					if(strcmp(input, "reschedule")==0){
						thiefreschedule(thiefp, &myseed);
						changed=1;
						return 0;
					}
					if(strcmp(input, "exit")==0){
						done=1;
					}
				}
			}
			wprintw(win, "armor:\n");
			wrefresh(win);
			if(thiefp->shield){
				myshield=armor_hop(thiefp->shield, win);
				free(myshield);
			}
			if(thiefp->armor){
				myarmor=armor_hop(thiefp->armor, win);
				free(myarmor);
			}
			wprintw(win, "weapons:\n");
			if(thiefp->weaponone){
				myweapone=weap_hop(thiefp->weaponone, win);
				free(myweapone);
			}
			if(thiefp->weapontwo){
				myweaptwo=weap_hop(thiefp->weapontwo, win);
				free(myweaptwo);
			}
			wprintw(win, "str: %d %d\n", thiefp->stat.str, thiefp->stat.strbon);
			wprintw(win, "int: %d %d\n", thiefp->stat.intel, thiefp->stat.intelbon);
			wprintw(win, "wis: %d %d\n", thiefp->stat.wis, thiefp->stat.wisbon);
			wprintw(win, "dex: %d %d\n", thiefp->stat.dex, thiefp->stat.dexbon);
			wprintw(win, "con: %d %d\n", thiefp->stat.con, thiefp->stat.conbon);
			wprintw(win, "cha: %d %d\n", thiefp->stat.cha, thiefp->stat.chabon);
			wprintw(win, "%s\n", thiefp->stat.prsnlty);
			wprintw(win, "%s\n", thiefp->stat.bckgrnd);
			wprintw(win, "mechanics:\n");
			wprintw(win, "MAXHP: %d HP: %d AC: %d thaco: %d\n", thiefp->stat.maxhp, thiefp->stat.curhp, thiefp->stat.ac, thiefp->stat.thaco);
			wrefresh(win);
			if(thiefp->stat.maxhp>thiefp->stat.curhp){
				thiefp->stat.curhp=thiefp->stat.maxhp;
				changed=1;
				wprintw(win, "Recovery time awarded. MAXHP: %d HP: %d\n", thiefp->stat.maxhp, thiefp->stat.curhp);
			}
			if(changed){
				remove("thief.bin");
				if((thieffpout=fopen(argv[1], "wb")) == NULL){
					wprintw(win, "file not found\n");
					return 255;
				}
				fwrite(thieffpout, sizeof(struct thief), 1, thieffpout);
				free(thiefp);
				fclose(thieffpout);
			}
			wrefresh(win);
		}
	}
	else if((strcmp(argv[1], "cleric.bin"))==0){
		if((clericfpin = fopen(argv[1], "rb")) == NULL){
			wprintw(win, "file not opened\n");
			return 3;
		}
		if(clericp=malloc(sizeof(struct cleric))){
			if( (fread(clericp, sizeof(struct cleric), 1, clericfpin)) ){
				if(feof(clericfpin)) wprintw(win, "premature end of file.");
			}
		}
		fclose(clericfpin);
		wprintw(win, "%s\n", clericp->stat.name);
		if(clericp->stat.ldr)wprintw(win, "deceased heroe\n");
		wprintw(win, "level: %d\n", clericp->stat.level);
		wprintw(win, "earned points: %d\n", clericp->stat.points);
		wprintw(win, "gold: %d\n", clericp->coin);
		wprintw(win, "target to reach level %d: %d\n", clericp->stat.level+1, clericp->stat.target);
		wrefresh(win);
		if(!(clericp->stat.ldr)){
			if(clericp->stat.points>clericp->stat.target){
				wprintw(win, "rescheduling is required.\n");
				done=0;
				while(!done){
					wprintw(win, "> ");
					wgetnstr(win, input, 40);
					if(strcmp(input, "reschedule")==0){
						clericreschedule(clericp, &myseed);
						changed=1;
						return 0;
					}
					if(strcmp(input, "exit")==0){
						done=1;
					}
				}
			}
			wprintw(win, "armor:\n");
			if(clericp->shield){ /* hopping will print */
				myshield=armor_hop(clericp->shield, win);
				free(myshield); /* no longer needed */
			}
			if(clericp->armor){
				myarmor=armor_hop(clericp->armor, win);
				free(myarmor);
			}
			wprintw(win, "weapons:\n");
			if(clericp->weaponone){
				myweapone=weap_hop(clericp->weaponone, win);
				free(myweapone);
			}
			if(clericp->weapontwo){
				myweaptwo=weap_hop(clericp->weapontwo, win);
				free(myweaptwo);
			}
			wprintw(win, "str: %d %d\n", clericp->stat.str, clericp->stat.strbon);
			wprintw(win, "int: %d %d\n", clericp->stat.intel, clericp->stat.intelbon);
			wprintw(win, "wis: %d %d\n", clericp->stat.wis, clericp->stat.wisbon);
			wprintw(win, "dex: %d %d\n", clericp->stat.dex, clericp->stat.dexbon);
			wprintw(win, "con: %d %d\n", clericp->stat.con, clericp->stat.conbon);
			wprintw(win, "cha: %d %d\n", clericp->stat.cha, clericp->stat.chabon);
			wprintw(win,"%s\n", clericp->stat.prsnlty);
			wprintw(win, "%s\n", clericp->stat.bckgrnd);
			wprintw(win, "mechanics:\n");
			wprintw(win, "MAXHP: %d HP: %d AC: %d thaco: %d\n", clericp->stat.maxhp, clericp->stat.curhp, clericp->stat.ac, clericp->stat.thaco);
			wrefresh(win);
			if(clericp->stat.maxhp>clericp->stat.curhp){
				clericp->stat.curhp=clericp->stat.maxhp;
				changed=1;
				wprintw(win, "Recovery time awarded. MAXHP: %d HP: %d\n", clericp->stat.maxhp, clericp->stat.curhp);
			}
			if(changed){
				remove("cleric.bin");
				if((clericfpout=fopen("cleric.bin", "wb")) == NULL){ 
					wprintw(win, "file not found\n");  
					return 255;
				}
				if( (fwrite(clericp, sizeof(struct cleric), 1, clericfpout)) != 1){
						wprintw(win, "write object failed\n");
				}
				free(clericp);
				fclose(clericfpout);
			}
			wrefresh(win);
		}
	}
	else if((strcmp(argv[1], "magicuser.bin"))==0){
		if((magicuserfpin = fopen(argv[1], "rb")) == NULL){
			wprintw(win, "file not opened %s\n", argv[1]);
			return 2;
		}
		if(magicuserp=malloc(sizeof(struct magicuser))){
			if( (fread(magicuserp, sizeof(struct magicuser), 1, magicuserfpin)) ){
				if(feof(magicuserfpin)) wprintw(win, "premature end of file.");
			}
		}
		fclose(magicuserfpin);
		wprintw(win, "%s\n", magicuserp->stat.name);
		if(magicuserp->stat.ldr)wprintw(win, "deceased heroe\n");
		wprintw(win, "level: %d\n", magicuserp->stat.level);
		wprintw(win, "earned points: %d\n", magicuserp->stat.points);
		wprintw(win, "target to reach level %d: %d\n", magicuserp->stat.level+1, magicuserp->stat.target);
		wrefresh(win);
		if(!(magicuserp->stat.ldr)){
			if(magicuserp->stat.points>magicuserp->stat.target){
				wprintw(win, "reschedule is necessary.\n");
				done=0;
				while(!done){
					wprintw(win, "> ");
					wgetnstr(win, input, 40);
					if(strcmp(input, "reschedule")==0){
						magicuserreschedule(magicuserp, &myseed);
						changed=1;
						return 0;
					}
					if(strcmp(input, "exit")==0){
						done=1;
					}
				}
			}
			wprintw(win, "weapons:\n");
			if(magicuserp->weaponone){
				myweapone=weap_hop(magicuserp->weaponone, win);
				free(myweapone);
			}
			if(magicuserp->weapontwo){
				myweaptwo=weap_hop(magicuserp->weapontwo, win);
				free(myweaptwo);
			}
			wprintw(win, "str: %d %d\n", magicuserp->stat.str, magicuserp->stat.strbon);
			wprintw(win, "int: %d %d\n", magicuserp->stat.intel, magicuserp->stat.intelbon);
			wprintw(win, "wis: %d %d\n", magicuserp->stat.wis, magicuserp->stat.wisbon);
			wprintw(win, "dex: %d %d\n", magicuserp->stat.dex, magicuserp->stat.dexbon);
			wprintw(win, "con: %d %d\n", magicuserp->stat.con, magicuserp->stat.conbon);
			wprintw(win, "cha: %d %d\n", magicuserp->stat.cha, magicuserp->stat.chabon);
			wprintw(win, "%s\n", magicuserp->stat.prsnlty);
			wprintw(win, "%s\n", magicuserp->stat.bckgrnd);
			wprintw(win, "mechanics:\n");
			wprintw(win, "MAXHP: %d HP: %d AC: %d thaco: %d\n", magicuserp->stat.maxhp, magicuserp->stat.curhp, magicuserp->stat.ac, magicuserp->stat.thaco);
			wrefresh(win);
			if(magicuserp->stat.maxhp>magicuserp->stat.curhp){
				magicuserp->stat.curhp=magicuserp->stat.maxhp;
				changed=1;
				wprintw(win, "Recovery time awarded. MAXHP: %d HP: %d\n", magicuserp->stat.maxhp, magicuserp->stat.curhp);
			}
			if(changed){
				if((magicuserfpout=fopen(argv[1], "wb")) == NULL){
					wprintw(win, "file not found\n");
					return 255;
				}
				fwrite(magicuserp, sizeof(struct magicuser), 1, magicuserfpout);
				free(magicuserp);
				free(myshield);
				free(myarmor);
				free(myweapone);
				free(myweaptwo);
				fclose(magicuserfpout);
			}
		}
	}
	else {
			wprintw(win, "file not recognised %s\n", argv[1]);
			return 3;
	}
	wrefresh(win);
	free(win);
	return 0;
}


void
fighterreschedule(struct fighter* p, long *seed){
	if(p->stat.level==3){
		p->stat.target=8000;
		p->stat.level++;
		p->stat.maxhp+=((ran0(seed))*8)+1;
		p->stat.maxhp+=p->stat.conbon;
		p->stat.thaco=17;
	}
	return;
}

void
clericreschedule(struct cleric* p, long *seed){
	if(p->stat.level==3){
		p->stat.target=6000;
		p->stat.level++;
		p->stat.maxhp+=((ran0(seed))*6)+1;
		p->stat.maxhp+=p->stat.conbon;
		p->spells[0][0]=1;
		p->spells[0][1]=1;
		p->spells[0][2]=1;
		p->spells[0][3]=1;
		p->spells[1][0]=1;
		p->spellsperlevel[0]=2;
		p->spellsperlevel[1]=1;
		p->turnundead[0]=TURND;
		p->turnundead[1]=TURNT;
		p->turnundead[2]=TURNT;
		p->turnundead[3]=TURNSEVEN;
		p->turnundead[4]=TURNNINE;
		p->turnundead[5]=TURNELEVEN;
		p->turnundead[6]=TURNBLANK;
		p->turnundead[7]=TURNBLANK;
		p->turnundead[8]=TURNBLANK;
		p->turnundead[9]=TURNBLANK;
		p->turnundead[10]=TURNBLANK;
		p->turnundead[11]=TURNBLANK;
		p->turnundead[12]=TURNBLANK;
		p->turnundead[13]=TURNBLANK;		
	}
	return;
}

void
thiefreschedule(struct thief* p, long *seed){
	if(p->stat.level==3){
		p->stat.target=4800;
		p->stat.level++;
		p->stat.maxhp+=((ran0(seed))*4)+1;
		p->stat.maxhp+=p->stat.conbon;
		p->readlanguages=1;
	}
	return;
}

void
magicuserreschedule(struct magicuser* p, long *seed){
	if(p->stat.level==3){
		p->stat.target=10000;
		p->stat.level++;
		p->stat.maxhp+=((ran0(seed))*4)+1;
		p->stat.maxhp+=p->stat.conbon;
		p->spells[0][0]=1;
		p->spells[0][1]=1;
		p->spells[0][2]=1;
		p->spells[0][3]=1;
		p->spellsperlevel[0]=2;
		p->spellsperlevel[1]=1;
	}
	return;
}
