#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <basics.h>
#include <math.h>
#include "cleric.h"
#include "magicuser.h"
#include "fighter.h"
#include "thief.h"
#include "monsters.h"
#include "libdungeon.h"

#define MYTRUE 0x800
#define MYFALSE 0x900

#define CLERIC 0x1000
#define FIGHTER 0x2000
#define MAGICUSER 0x3000
#define THIEF 0x4000

struct room* roomone(void);
struct room* roomtwo(void);
struct room* roomthree(void);
struct room* roomfour(void);
struct room* roomfive(void);
void hallone(struct hall*);

int trapcheck(int, int*, int*, long*);

struct monster* orc(long*);
struct monster* firebeetle(long*);
int clericcombat(struct cleric*, struct monster*, long*);
int fightercombat(struct fighter*, struct monster*, long*);
int magicusercombat(struct magicuser*, struct monster*, long*);
int thiefcombat(struct thief*, struct monster*, long*);


int
main(int argc, char *argv[]){
	FILE *clericfp; /* one pointer may be used per program per file */
	FILE *fighterfp;
	FILE *magicuserfp;
	FILE *thieffp;
	FILE *clericout;
	FILE *fighterout;
	FILE *thiefout;
	FILE *magicuserout;
	struct cleric *clericp;
	struct fighter *fighterp;
	struct magicuser *magicuserp;
	struct thief *thiefp;
	armor *myshield;
	armor *myarmor;
	struct room *roomp;
	struct hall *hallp;
	struct hall myhallone;/* this listing lengthens */
	/* change the pointer to each different hall */
	struct monster *encounter_monst;
	int chamber;
	int done;
	int command;
	char input[50];
	int enemy[2]; /* in subsequent dungeons this is an array */
	int i;
	int key;
	int once;
	int character_class;
	int traponce;
	int position;
	long seed;
	int secret;

	if(argc!=3)return 1;

	seed=atol(argv[2]);

	if((strcmp(argv[1], "cleric.bin"))==0){
		character_class=CLERIC;
		if((clericfp = fopen(argv[1], "rb")) == NULL){
			printf("file not found\n");
			return 2;
		}
		if(clericp=malloc(sizeof(struct cleric))){
			if( (fread(clericp, sizeof(struct cleric), 1, clericfp)) ){
				if(feof(clericfp)) printf("premature end of file.");
			}
			fclose(clericfp);
		}
		printf("%s\n", clericp->stat.name);
		if(clericp->stat.ldr==1){
			printf("defeated.\n");
			free(clericp);
			return 1;
		}
		if(clericp->stat.level>1){
			printf("first level clerics only\n");
			return 1;
		}
	}
	else if((strcmp(argv[1], "fighter.bin"))==0){
		character_class=FIGHTER;
		if((fighterfp = fopen(argv[1], "rb")) == NULL){
			printf("file not found\n");
			return 2;
		}
		if(fighterp=malloc(sizeof(struct fighter))){
			if( (fread(fighterp, sizeof(struct fighter), 1, fighterfp)) ){
				if(feof(fighterfp)) printf("premature end of file.");
			}
			fclose(fighterfp);
		}
		printf("%s\n", fighterp->stat.name);
		if(fighterp->stat.ldr==1){
			printf("defeated.\n");
			free(fighterp);
			return 1;
		}
		if(fighterp->stat.level>1){
			printf("first level fighters only\n");
			return 1;
		}
	}
	else if((strcmp(argv[1], "magicuser.bin"))==0){
		character_class=MAGICUSER;
		if((magicuserfp = fopen(argv[1], "rb")) == NULL){
			printf("file not found\n");
			return 2;
		}
		if(magicuserp=malloc(sizeof(struct magicuser))){
			if( (fread(magicuserp, sizeof(struct magicuser), 1, magicuserfp)) ){
				if(feof(magicuserfp)) printf("premature end of file.");
			}
			fclose(magicuserfp);
		}
		printf("%s\n", magicuserp->stat.name);
		if(magicuserp->stat.ldr==1){
			printf("defeated.\n");
			free(fighterp);
			return 1;
		}
		if(magicuserp->stat.level>1){
			printf("first level magicusers only\n");
			return 1;
		}
	}
	else if((strcmp(argv[1], "thief.bin"))==0){
		character_class=THIEF;
		if((thieffp = fopen(argv[1], "rb")) == NULL){
			printf("file not found\n");
			return 2;
		}
		if(thiefp=malloc(sizeof(struct thief))){
			if( (fread(thiefp, sizeof(struct thief), 1, thieffp)) ){
				if(feof(thieffp)) printf("premature end of file.");
			}
			fclose(thieffp);
		}
		printf("%s\n", thiefp->stat.name);
		if(thiefp->stat.ldr==1){
			printf("defeated.\n");
			free(thiefp);
			return 1;
		}
		if(thiefp->stat.level>1){
			printf("first level thieves only\n");
			return 1;
		}
	}
	
	secret=0;
	done=0;
	chamber=ROOMONE;
	once=MYFALSE;
	traponce=MYFALSE;
	position=ROOM;
	hallp=&myhallone;
	hallone(&myhallone);
	while(!done){
		switch(chamber){
			case ROOMONE:
				position=ROOM;
				roomp=roomone();
				printf("%s", roomp->descr);
				break;
			case ROOMTWO:
				position=ROOM;
				roomp=roomtwo();
				printf("%s", roomp->descr);
				break;
			case ROOMTHREE:
				position=ROOM;
				roomp=roomthree();
				printf("%s", roomp->descr);
				if(enemy[0]==VANQUISHED)
					break;
				else {
					switch(roomp->encounter){
						case FIREBEETLE:
							encounter_monst=firebeetle(&seed);
							break;
						case ORC:
							encounter_monst=orc(&seed);
					}
					switch(character_class){
						case CLERIC:
						if(clericcombat(clericp, encounter_monst, &seed)){
							printf("Victory, the dungeon is yours.\n");
							enemy[0]=VANQUISHED;
							clericp->stat.points += encounter_monst->vanquished;
							printf("%d points earned\n", clericp->stat.points);
						}
						else {
							printf("You were defeated.\n");
							clericp->stat.ldr=1;
							if((clericout=fopen(argv[1], "wb")) == NULL){
								printf("Output file couldn't be opened\n");
								return 255;
							}
							if((fwrite(clericp, sizeof(struct cleric), 1, clericout)) != 1){
								printf("file not found\n");
								return 255;
							}
							fclose(clericout);
							free(clericp);
							free(encounter_monst);
							return 0;
						}
						break;

						case FIGHTER:
						if(fightercombat(fighterp, encounter_monst, &seed)){
							printf("Victory, the dungeon is yours.\n");
							enemy[0]=VANQUISHED;
							fighterp->stat.points += encounter_monst->vanquished;
							printf("%d points earned\n", fighterp->stat.points);
						}
						else {
							printf("You were defeated.\n");
							fighterp->stat.ldr=1;
							if((fighterout=fopen(argv[1], "wb")) == NULL){
								printf("Output file couldn't be opened\n");
								return 255;
							}
							if((fwrite(fighterp, sizeof(struct fighter), 1, fighterout)) != 1){
								printf("file not found\n");
								return 255;
							}
							fclose(fighterout);
							free(fighterp);
							free(encounter_monst);
							return 0;
						}
						break;

						case MAGICUSER:
						if(magicusercombat(magicuserp, encounter_monst, &seed)){
							printf("Victory, the dungeon is yours.\n");
							enemy[0]=VANQUISHED;
							magicuserp->stat.points += encounter_monst->vanquished;
							printf("%d points earned\n", magicuserp->stat.points);
						}
						else {
							printf("You were defeated.\n");
							magicuserp->stat.ldr=1;
							if((magicuserout=fopen(argv[1], "wb")) == NULL){
								printf("Output file couldn't be opened\n");
								return 255;
							}
							if((fwrite(magicuserp, sizeof(struct magicuser), 1, magicuserout)) != 1){
								printf("file not found\n");
								return 255;
							}
							fclose(magicuserout);
							free(magicuserp);
							free(encounter_monst);
							return 0;
						}
						break;

						case THIEF:
						if(thiefcombat(thiefp, encounter_monst, &seed)){
							printf("Victory, the dungeon is yours.\n");
							enemy[0]=VANQUISHED;
							thiefp->stat.points += encounter_monst->vanquished;
							printf("%d points earned\n", thiefp->stat.points);
						}
						else {
							printf("You were defeated.\n");
							thiefp->stat.ldr=1;
							if((thiefout=fopen(argv[1], "wb")) == NULL){
								printf("Output file couldn't be opened\n");
								return 255;
							}
							if((fwrite(thiefp, sizeof(struct thief), 1, thiefout)) != 1){
								printf("file not found\n");
								return 255;
							}
							fclose(thiefout);
							free(thiefp);
							free(encounter_monst);
							return 0;
						}
						break;
						
					}
					free(encounter_monst);
				}
				break;
			case ROOMFOUR:
				position=ROOM;
				roomp=roomfour();
				printf("%s", roomp->descr);
				break;
			case ROOMFIVE:
				position=ROOM;
				roomp=roomfive();
				printf("%s", roomp->descr);
				if(enemy[1]==VANQUISHED)
					break;
				else {
					switch(roomp->encounter){
						case FIREBEETLE:
							encounter_monst=firebeetle(&seed);
							break;
						case ORC:
							encounter_monst=orc(&seed);
							break;
					}
					encounter_monst=orc(&seed);
					switch(character_class){
						case CLERIC:
						if(clericcombat(clericp, encounter_monst, &seed)){
							printf("Victory, the dungeon is yours.\n");
							enemy[1]=VANQUISHED;
							clericp->stat.points += encounter_monst->vanquished;
							printf("%d points earned\n", clericp->stat.points);
						}
						else {
							printf("You were defeated.\n");
							clericp->stat.ldr=1;
							if((clericout=fopen(argv[1], "wb")) == NULL){
								printf("Output file couldn't be opened\n");
								return 255;
							}
							if((fwrite(clericp, sizeof(struct cleric), 1, clericout)) != 1){
								printf("file not found\n");
								return 255;
							}
							fclose(clericout);
							free(clericp);
							free(encounter_monst);
							return 0;
						}
						break;

						case FIGHTER:
						if(fightercombat(fighterp, encounter_monst, &seed)){
							printf("Victory, the dungeon is yours.\n");
							enemy[1]=VANQUISHED;
							fighterp->stat.points += encounter_monst->vanquished;
							printf("%d points earned\n", fighterp->stat.points);
						}
						else {
							printf("You were defeated.\n");
							fighterp->stat.ldr=1;
							if((fighterout=fopen(argv[1], "wb")) == NULL){
								printf("Output file couldn't be opened\n");
								return 255;
							}
							if((fwrite(fighterp, sizeof(struct fighter), 1, fighterout)) != 1){
								printf("file not found\n");
								return 255;
							}
							fclose(fighterout);
							free(fighterp);
							free(encounter_monst);
							return 0;
						}
						break;

						case MAGICUSER:
						if(magicusercombat(magicuserp, encounter_monst, &seed)){
							printf("Victory, the dungeon is yours.\n");
							enemy[1]=VANQUISHED;
							magicuserp->stat.points += encounter_monst->vanquished;
							printf("%d points earned\n", magicuserp->stat.points);
						}
						else {
							printf("You were defeated.\n");
							magicuserp->stat.ldr=1;
							if((magicuserout=fopen(argv[1], "wb")) == NULL){
								printf("Output file couldn't be opened\n");
								return 255;
							}
							if((fwrite(magicuserp, sizeof(struct magicuser), 1, magicuserout)) != 1){
								printf("file not found\n");
								return 255;
							}
							fclose(magicuserout);
							free(magicuserp);
							free(encounter_monst);
							return 0;
						}
						break;

						case THIEF:
						if(thiefcombat(thiefp, encounter_monst, &seed)){
							printf("Victory, the dungeon is yours.\n");
							enemy[1]=VANQUISHED;
							thiefp->stat.points += encounter_monst->vanquished;
							printf("%d points earned\n", thiefp->stat.points);
						}
						else {
							printf("You were defeated.\n");
							thiefp->stat.ldr=1;
							if((thiefout=fopen(argv[1], "wb")) == NULL){
								printf("Output file couldn't be opened\n");
								return 255;
							}
							if((fwrite(thiefp, sizeof(struct thief), 1, thiefout)) != 1){
								printf("file not found\n");
								return 255;
							}
							fclose(thiefout);
							free(thiefp);
							free(encounter_monst);
							return 0;
						}
						break;
					}
					free(encounter_monst);
				}
				break;
			case HALLONE:
				position=HALL;
				switch(hallp->salient){
					case NORTHSOUTH:
						if(hallp->end==NORTHEND){
							printf("%s", hallp->contextAdescr);
						}
						else if(hallp->end==SOUTHEND){
							printf("%s", hallp->contextBdescr);
						}
						break;
					case EASTWEST:
						if(hallp->end==WESTEND){
							printf("%s", hallp->contextAdescr);
						}
						else if(hallp->end==EASTEND){
								printf("%s", hallp->contextBdescr);
						}
						break;
				}
			break;
		}
		if(character_class==CLERIC&&traponce==MYFALSE&&roomp->trap!=NOTRAP){
			if(trapcheck(roomp->trap, &clericp->stat.saving_throws[DEATHRAYPOISON], &clericp->stat.curhp, &seed)){
				clericp->stat.ldr=1;
				if((clericout=fopen(argv[1], "wb")) == NULL){
					printf("Output file couldn't be opened\n");
					return 255;
				}
				if((fwrite(clericp, sizeof(struct cleric), 1, clericout)) != 1){
					printf("file not found\n");
					return 255;
				}
				fclose(clericout);
				return 0;
			}
			else traponce=MYTRUE;
		}
		else if(character_class==FIGHTER&&traponce==MYFALSE&&roomp->trap!=NOTRAP){
			if(trapcheck(roomp->trap, &fighterp->stat.saving_throws[DEATHRAYPOISON], &fighterp->stat.curhp, &seed)){
				fighterp->stat.ldr=1;
				if((fighterout=fopen(argv[1], "wb")) == NULL){
					printf("Output file couldn't be opened\n");
					return 255;
				}
				if((fwrite(fighterp, sizeof(struct fighter), 1, fighterout)) != 1){
					printf("file not found\n");
					return 255;
				}
				fclose(fighterout);
				return 0;
			}
			else traponce=MYTRUE;
		}
		else if(character_class==MAGICUSER&&traponce==MYFALSE&&roomp->trap!=NOTRAP){
			if(trapcheck(roomp->trap, &magicuserp->stat.saving_throws[DEATHRAYPOISON], &magicuserp->stat.curhp, &seed)){
				magicuserp->stat.ldr=1;
				if((magicuserout=fopen(argv[1], "wb")) == NULL){
					printf("Output file couldn't be opened\n");
					return 255;
				}
				if((fwrite(magicuserp, sizeof(struct magicuser), 1, magicuserout)) != 1){
					printf("file not found\n");
					return 255;
				}
				fclose(magicuserout);
				return 0;
			}
			else traponce=MYTRUE;
		}
		else if(character_class==THIEF&&traponce==MYFALSE&&roomp->trap!=NOTRAP){
			if(trapcheck(roomp->trap, &thiefp->stat.saving_throws[DEATHRAYPOISON], &thiefp->stat.curhp, &seed)){
				thiefp->stat.ldr=1;
				if((thiefout=fopen(argv[1], "wb")) == NULL){
					printf("Output file couldn't be opened\n");
					return 255;
				}
				if((fwrite(thiefp, sizeof(struct thief), 1, thiefout)) != 1){
					printf("file not found\n");
					return 255;
				}
				fclose(thiefout);
				return 0;
			}
			else traponce=MYTRUE;
		}
		fflush(stdout);
		for(i=0; i<50; i++)input[i]=(int)NULL;
		command=1;
		while(command){
			switch(character_class){
				case CLERIC:
				if(clericp->stat.points > clericp->stat.target){
					clericp->stat.level++;
					clericp->stat.maxhp+=((ran0(&seed)*6)+1);
					clericp->stat.maxhp+=clericp->stat.conbon;
					clericp->stat.target=3000;
					if((clericout=fopen(argv[1], "wb")) == NULL){
						printf("Output file couldn't be opened\n");
						return 255;
					}
					if((fwrite(clericp, sizeof(struct cleric), 1, clericout)) != 1){
						printf("file not found\n");
						return 255;
					}
					fclose(clericout);
				}
				break;

				case FIGHTER:
				if(fighterp->stat.points > fighterp->stat.target){
					fighterp->stat.level++;
					fighterp->stat.maxhp+=((ran0(&seed)*8)+1);
					fighterp->stat.maxhp+=fighterp->stat.conbon;
					fighterp->stat.target=4000;
					if((fighterout=fopen(argv[1], "wb")) == NULL){
						printf("Output file couldn't be opened\n");
						return 255;
					}
					if((fwrite(fighterp, sizeof(struct fighter), 1, fighterout)) != 1){
						printf("file not found\n");
						return 255;
					}
					fclose(fighterout);
				}
				break;

				case MAGICUSER:
				if(magicuserp->stat.points > magicuserp->stat.target){
					magicuserp->stat.level++;
					magicuserp->stat.maxhp+=((ran0(&seed)*4)+1);
					magicuserp->stat.maxhp+=magicuserp->stat.conbon;
					magicuserp->stat.target=5000;
					if((magicuserout=fopen(argv[1], "wb")) == NULL){
						printf("Output file couldn't be opened\n");
						return 255;
					}
					if((fwrite(magicuserp, sizeof(struct magicuser), 1, magicuserout)) != 1){
						printf("file not found\n");
						return 255;
					}
					fclose(magicuserout);
				}
				break;

				case THIEF:
				if(thiefp->stat.points > thiefp->stat.target){
					thiefp->stat.level++;
					thiefp->stat.maxhp+=((ran0(&seed)*4)+1);
					thiefp->stat.maxhp+=thiefp->stat.conbon;
					thiefp->stat.target=2400;
					if((thiefout=fopen(argv[1], "wb")) == NULL){
						printf("Output file couldn't be opened\n");
						return 255;
					}
					if((fwrite(thiefp, sizeof(struct thief), 1, thiefout)) != 1){
						printf("file not found\n");
						return 255;
					}
					fclose(thiefout);
				}
				break;
			}
			printf("dungeon001> ");

			fflush(stdout);
			gets(input);
			if(strcmp(input, "north")==0){
				if(position==ROOM){
					if(roomp->brush[2]!=WALL && roomp->brushdoors[2]==LOCKED){
						printf("Door is locked.\n");
					}
					else {
						if(roomp->brush[2]==WALL){
							printf("Further is a wall.\n");
						}
					}
					if(roomp->brush[2]==DOOR && roomp->brushdoors[2]==UNLOCKED){
						chamber=roomp->traversal[2];
						free(roomp);
					}
					else if(roomp->brush[2]==DOOR && key==KEYFOUND){
						chamber=roomp->traversal[2];
						free(roomp);
					}
					break;
				}
				else if(position==HALL) {
					if(hallp->salient==NORTHSOUTH){
						if(hallp->brush[3]!=WALL && hallp->brushdoors[3]==LOCKED){
							printf("Door is locked.\n");
						}
						else {
							if(hallp->brush[3]==WALL){
								printf("Further is a wall.\n");
							}
						}
						if(hallp->brush[3]==DOOR && hallp->brushdoors[3]==UNLOCKED){
							chamber=hallp->traversal[3];
						}
						else if(roomp->brush[3]==DOOR && key==KEYFOUND){
							chamber=hallp->traversal[3];
						}
						break;
					}
					if(hallp->salient==EASTWEST) {
						if(hallp->end==EASTEND){
							if(hallp->brush[1]!=WALL && hallp->brushdoors[1]==LOCKED){
								printf("Door is locked.\n");
							}
							else {
								if(hallp->brush[1]==WALL) {
									printf("Further is a wall.\n");
								}
							}
							if(hallp->brush[1]==DOOR && hallp->brushdoors[1]==UNLOCKED){
								chamber=hallp->traversal[1];
							}
							else if(hallp->brush[1]==DOOR && key==KEYFOUND){
								chamber=hallp->traversal[1];
							}
							break;
						}
						else if(hallp->end==WESTEND){
							if(hallp->brush[2]!=WALL && hallp->brushdoors[2]==LOCKED){
								printf("Door is locked.\n");
							}
							else{
								if(hallp->brush[2]==WALL){
									printf("Further is a wall.\n");
								}
							}
							if(hallp->brush[2]==DOOR && hallp->brushdoors[2]==UNLOCKED){
								chamber=hallp->traversal[2];
							}
							else if(hallp->brush[2]==DOOR && key==KEYFOUND){
								chamber=hallp->traversal[2];
							}
							break;
						}
					}
				}
			}
			else if(strcmp(input, "south")==0){
				if(chamber==ROOMONE){
					free(roomp);
					return 0;
				}
				if(position==ROOM){
					if(roomp->brush[0]!=WALL && roomp->brushdoors[0]==LOCKED){
						printf("Door is locked.\n");
					}
					else {
						if(roomp->brush[0]==WALL){
							printf("Further is a wall.\n");
						}
					}
					if(roomp->brush[0]==DOOR && roomp->brushdoors[0]==UNLOCKED){
						chamber=roomp->traversal[0];
						free(roomp);
					}
					else if(roomp->brush[0]==DOOR && key==KEYFOUND){
						chamber=roomp->traversal[0];
						free(roomp);
					}
					break;
				}
				else if(position==HALL) {
					if(hallp->salient==NORTHSOUTH){
						if(hallp->brush[0]!=WALL && hallp->brushdoors[0]==LOCKED){
							printf("Door is locked.\n");
						}
						else {
							if(hallp->brush[0]==WALL){
								printf("Further is a wall.\n");
							}
						}
						if(hallp->brush[0]==DOOR && hallp->brushdoors[0]==UNLOCKED){
							chamber=hallp->traversal[0];

						}
						else if(roomp->brush[0]==DOOR && key==KEYFOUND){
							chamber=hallp->traversal[0];
						}
						break;
					}
					else if(hallp->salient==EASTWEST) {
						if(hallp->end==EASTEND){
							if(hallp->brush[4]!=WALL && hallp->brushdoors[4]==LOCKED){
								printf("Door is locked.\n");
							}
							else {
								if(hallp->brush[4]==WALL) {
									printf("Further is a wall.\n");
								}
							}
							if(hallp->brush[4]==DOOR && hallp->brushdoors[4]==UNLOCKED){
								chamber=hallp->traversal[4];
							}
							else if(hallp->brush[4]==DOOR && key==KEYFOUND){
								chamber=hallp->traversal[4];
							}
							break;
						}
						else if(hallp->end==WESTEND){
							if(hallp->brush[5]!=WALL && hallp->brushdoors[5]==LOCKED){
								printf("Door is locked.\n");
							}
							else {
								if(hallp->brush[5]==WALL){
									printf("Further is a wall.\n");
								}
							}
							if(hallp->brush[5]==DOOR && hallp->brushdoors[5]==UNLOCKED){
								chamber=hallp->traversal[5];
							}
							else if(hallp->brush[5]==DOOR && key==KEYFOUND){
								chamber=hallp->traversal[5];
							}
							break;
						}
					}
				}
			}
			else if(strcmp(input, "west")==0){
				if(position==ROOM){
					if(roomp->brush[1]!=WALL && roomp->brushdoors[1]==LOCKED){
						printf("Door is locked.\n");
					}
					else {
						if(roomp->brush[1]==WALL){
							printf("Further is a wall.\n");
						}
					}
					if(roomp->brush[1]==DOOR && roomp->brushdoors[1]==UNLOCKED){
						chamber=roomp->traversal[1];
						free(roomp);
					}
					else if(roomp->brush[1]==DOOR && key==KEYFOUND){
						chamber=roomp->traversal[1];
						free(roomp);
					}
					break;
				} 
				else if(position==HALL) {
					if(hallp->salient==EASTWEST){
						if(hallp->brush[0]!=WALL && hallp->brushdoors[0]==LOCKED){
							printf("Door is locked.\n");
						}
						else {
							if(hallp->brush[0]==WALL){
								printf("Further is a wall.\n");
							}
						}
						if(hallp->brush[0]==DOOR && hallp->brushdoors[0]==UNLOCKED){
							chamber=hallp->traversal[0];
						}
						else if(roomp->brush[0]==DOOR && key==KEYFOUND){
							chamber=hallp->traversal[0];
						}
						break;
					}
					else if(hallp->salient==NORTHSOUTH){
						if(hallp->end==NORTHEND){
							if(hallp->brush[2]!=WALL && hallp->brushdoors[2]==LOCKED){
								printf("Door is locked.\n");
							}
							else {
								if(hallp->brush[2]==WALL){
									printf("Further is a wall.\n");
								}
							}
							if(hallp->brush[2]==DOOR && hallp->brushdoors[2]==UNLOCKED){
								chamber=hallp->traversal[2];
							}
							else if(hallp->brush[2]==DOOR && key==KEYFOUND){
								chamber=hallp->traversal[2];
							}
							break;
						}
						else if(hallp->end==SOUTHEND){
							if(hallp->brush[1]!=WALL && hallp->brushdoors[1]==LOCKED){
								printf("Door is locked.\n");
							}
							else {
								if(hallp->brush[1]==WALL){
									printf("Further is a wall.\n");
								}
							}
							if(hallp->brush[1]==DOOR && hallp->brushdoors[1]==UNLOCKED){
								chamber=hallp->traversal[1];
							}
							else if(hallp->brush[1]==DOOR && key==KEYFOUND){
								chamber=hallp->traversal[1];
							}
							break;
						}
					}
				}
			}
			else if(strcmp(input, "east")==0){
				if(position==ROOM){
					if(roomp->brush[3]!=WALL && roomp->brushdoors[3]==LOCKED){
						printf("Door is locked.\n");
					}
					else {
						if(roomp->brush[3]==WALL){
							printf("Further is a wall.\n");
						}
					}
					if(roomp->brush[3]==DOOR && roomp->brushdoors[3]==UNLOCKED){
						chamber=roomp->traversal[3];
						free(roomp);
					}
					else if(roomp->brush[3]==DOOR && key==KEYFOUND){
						chamber=roomp->traversal[3];
						free(roomp);
					}
					break;
				} 
				else if(position==HALL) {
					if(hallp->salient==EASTWEST){ /* now be careful the orientation is the zero in the west to three in the east */
						if(hallp->brush[3]!=WALL && hallp->brushdoors[3]==LOCKED){
							printf("Door is locked.\n");
						}
						else {
							if(hallp->brush[3]==WALL){
								printf("Further is a wall.\n");
							}
						}
						if(hallp->brush[3]==DOOR && hallp->brushdoors[3]==UNLOCKED){
							chamber=hallp->traversal[3];
						}
						else if(roomp->brush[3]==DOOR && key==KEYFOUND){
							chamber=hallp->traversal[3];
						}
						break;
					}
					else if(hallp->salient==NORTHSOUTH){
						if(hallp->end==NORTHEND){
							if(hallp->brush[4]!=WALL && hallp->brushdoors[4]==LOCKED){
								printf("Door is locked.\n");
							}
							else{
								if(hallp->brush[4]==WALL){
									printf("Further is a wall.\n");
								}
							}
							if(hallp->brush[4]==DOOR && hallp->brushdoors[4]==UNLOCKED){
								chamber=hallp->traversal[4];
							}
							else if(hallp->brush[4]==DOOR && key==KEYFOUND){
								chamber=hallp->traversal[4];
							}
							break;
						}
						else if(hallp->end==SOUTHEND){
							if(hallp->brush[5]!=WALL && hallp->brushdoors[5]==LOCKED){
								printf("Door is locked.\n");
							}
							else{
								if(hallp->brush[5]==WALL){
									printf("Further is a wall.\n");
								}
							}
							if(hallp->brush[5]==DOOR && hallp->brushdoors[5]==UNLOCKED){
								chamber=hallp->traversal[5];
							}
							else if(hallp->brush[5]==DOOR && key==KEYFOUND){
								chamber=hallp->traversal[5];
							}
							break;
						}
					}
				}
			}
			else if(strcmp(input, "search")==0){
				switch(character_class){
					case CLERIC:
					if(roomp->key==KEYFOUND){
						key=KEYFOUND;
						printf("You found the key to any locked door in the dungeon.\n");
						clericp->stat.points+= 500;
						printf("earned points %d\n", clericp->stat.points);
					}
					if(roomp->treasure==TREASURE && once==MYFALSE){
						printf("You have found the raider treasures!\n");
						clericp->stat.points += roomp->value;
						clericp->coin += roomp->value;
						printf("earned points %d\n", clericp->stat.points);
						once=MYTRUE;
					}
					if(chamber==ROOMFOUR){
						if( ((ran0(&seed)*12)+1) <= 4){
							secret=1;
							chamber=roomp->traversal[1]; 
							once=MYFALSE;
							command=0;
						}
					}
					break;

					case FIGHTER:
					if(roomp->key==KEYFOUND){
						key=KEYFOUND;
						printf("You found the key to any locked door in the dungeon.\n");
						fighterp->stat.points+= 500;
						printf("earned points %d\n", fighterp->stat.points);
					}
					if(roomp->treasure==TREASURE && once==MYFALSE){
						printf("You have found the raider treasures!\n");
						fighterp->stat.points += roomp->value;
						fighterp->coin += roomp->value;
						printf("earned points %d\n", fighterp->stat.points);
						once=MYTRUE;
					}
					if(chamber==ROOMFOUR){
						if( ((ran0(&seed)*12)+1) <= 3){
							secret=1;
							chamber=roomp->traversal[1]; 
							once=MYFALSE;
							command=0;
						}
					}
					break;

					case MAGICUSER:
					if(roomp->key==KEYFOUND){
						key=KEYFOUND;
						printf("You found the key to any locked door in the dungeon.\n");
						magicuserp->stat.points+= 500;
						printf("earned points %d\n", magicuserp->stat.points);
					}
					if(roomp->treasure==TREASURE && once==MYFALSE){
						printf("You have found the raider treasures!\n");
						magicuserp->stat.points += roomp->value;
						magicuserp->coin += roomp->value;
						printf("earned points %d\n", magicuserp->stat.points);
						once=MYTRUE;
					}
					if(chamber==ROOMFOUR){
						if( ((ran0(&seed)*12)+1) <= 3){
							secret=1;
							chamber=roomp->traversal[1]; 
							once=MYFALSE;
							command=0;
						}
					}
					break;

					case THIEF:
					if(roomp->key==KEYFOUND){
						key=KEYFOUND;
						printf("You found the key to any locked door in the dungeon.\n");
						thiefp->stat.points+= 500;
						printf("earned points %d\n", thiefp->stat.points);
					}
					if(roomp->treasure==TREASURE && once==MYFALSE){
						printf("You have found the raider treasures!\n");
						thiefp->stat.points += roomp->value;
						thiefp->coin += roomp->value;
						printf("earned points %d\n", thiefp->stat.points);
						once=MYTRUE;
					}
					if(chamber==ROOMFOUR){
						if( ((ran0(&seed)*12)+1) <= 3){
							secret=1;
							chamber=roomp->traversal[1]; 
							once=MYFALSE;
							command=0;
						}
					}
					break;
				}
			}
			else if(strcmp(input, "crossfloor")==0){
				if(hallp){
					switch(hallp->salient){
						case NORTHSOUTH:
							if(hallp->end==SOUTHEND)
								hallp->end=NORTHEND;
							else 
								hallp->end=SOUTHEND;
							break;
						case EASTWEST:
							if(hallp->end==EASTEND)
								hallp->end=WESTEND;
							else
								hallp->end=EASTEND;
							break;
					}
					break;
				}
			}
			else if(strcmp(input, "map")==0){
				if(secret)secretmap();
				else showmap();
			}
		}
	}

	free(myshield);
	free(myarmor);


	return 0;
}

