#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <curses.h>
#include "basics.h"
#include "cleric.h"
#include "fighter.h"
#include "thief.h"
#include "magicuser.h"
#include "sqlite3ext.h"
#include "sqlite3.h"


int
main( int argc, char *argv[]) {
	struct fighter *fighterp;
	struct cleric *clericp;
	struct thief *thiefp;
	struct magicuser *magicuserp;

	FILE *clericfp;
	FILE *fighterfp;
	FILE *magicuserfp;
	FILE *thieffp;
	WINDOW *win;
	char filename[20];
	char tmp[50];
	int i;
	long seed;

	win=initscr();

	printf("usage: ./generator [fighter|cleric|thief|magicuser] [random seed]\n");
	if (argc!=3)
		return 1;

	for(i=0; i<20; i++)filename[i]='\0';

	strcat(filename, argv[1]);
	strcat(filename, ".bin"); /* allows windows to write a binary file */

	remove(filename);

	seed=atol(argv[2]);

	if(strcmp(argv[1], "fighter")==0){
		if((fighterfp = fopen(filename, "w+b")) == NULL){
			wprintw(win, "file open failed\n");
			return 3;
		}
		fighterp=fighter_creat(&seed);
		if(fwrite(fighterp, sizeof(struct fighter), 1, fighterfp) != 1)
			wprintw(win, "File write error.\n");
		free(fighterp); /* variously free the pointer before the file is closed */
		fclose(fighterfp);
		wrefresh(win);
	}
	else if(strcmp(argv[1], "cleric")==0){
		if((clericfp = fopen(filename, "w+b")) == NULL){
			wprintw(win, "file open failed\n");
			return 3;
		}
		clericp=cleric_creat(&seed);
		if(fwrite(clericp, sizeof(struct cleric), 1, clericfp) != 1)
			wprintw(win, "File write error.\n");
		free(clericp);
		fclose(clericfp);
		wrefresh(win);
	}
	else if(strcmp(argv[1], "thief")==0){
		if((thieffp = fopen(filename, "w+b")) == NULL){
			wprintw(win, "file open failed\n");
			return 3;
		}
		thiefp=thief_creat(&seed);
		if(fwrite(thiefp, sizeof(struct thief), 1, thieffp) != 1)
			wprintw(win, "File write error.\n");
		free(thiefp);
		fclose(thieffp);
		wrefresh(win);
	}
	else if(strcmp(argv[1], "magicuser")==0){
		if((magicuserfp = fopen(filename, "w+b")) == NULL){
			wprintw(win, "file open failed\n");
			return 3;
		}
		magicuserp=magicuser_creat(&seed);
		if(fwrite(magicuserp, sizeof(struct magicuser), 1, magicuserfp) != 1)
			wprintw(win, "File write error.\n");
		free(magicuserp);
		fclose(magicuserfp);
		wrefresh(win);
	}
	else return 2;
	free(win);

	return 0;
}


