#include "sqlite3.h"
#include <stdio.h>

int main(void){

	sqlite3 *db;
	char *err_msg = 0;

	int rc = sqlite3_open("coords.db", &db);

	if( rc != SQLITE_OK) {
		fprintf(stderr, "Cannot open database: %s\n", sqlite3_errmsg(db));
		sqlite3_close(db);

		return 1;
	}
	
	const char *sql[60] = {"DROP TABLE IF EXISTS TITLErec;",
				"CREATE TABLE TITLErec(Id IntVar(2), RECORD VARCHAR(120));",
				"INSERT INTO TITLErec VALUES(1,'konputa game busto');",
				"DROP TABLE IF EXISTS STAGErec;",
				"CREATE TABLE STAGErec(Id IntVar(2), RECORD VARCHAR(120));",
				"INSERT INTO STAGErec VALUES(1, 'stage one of three');",
			"DROP TABLE IF EXISTS DATArec;",
			"CREATE TABLE DATArec(Id IntVar(2), RECORD VARCHAR(2048));",
			"INSERT INTO DATArec VALUES(1,'elms and a farrier nook an old horseshoe crucible left untended');",
			"INSERT INTO DATArec VALUES(2,'a trail of deer lanced ipon a ridge up and away to untold adventure');",
			"INSERT INTO DATArec VALUES(3,'steps carven in to the windy reaches of the cold fells one misstep...');",
			"INSERT INTO DATArec VALUES(4,'a tumbled rock strewn way are for a number of cattle driven by per head of cattle and clansmen gather here for sales');",
			"INSERT INTO DATArec VALUES(5,'a wintery tressel of of struck pondsmiths of old the smoother stones arte a gathered tabernacle to stop the gap between swordsman and the poor');",
			"INSERT INTO DATArec VALUES(6,'the deeping dragonforest towering edifaces of wisdonm to clamber and climb a seelie and moss a creeper and a vine');",
			"INSERT INTO DATArec VALUES(7,'the wended travails of waterstone and brook');",
			"INSERT INTO DATArec VALUES(8,'the stonework and ever present maist driven windsand rain wetted and mossed the old buildingf stoof stood for four hundred years theres more the guildmasters of arcium declared it the posint posting of the northern mage madrid as it happensd to unfold the land champion found or muster');",
			"INSERT INTO DATArec VALUES(9,'fence lines and country roads in a patchwork quilt');",
			"INSERT INTO DATArec VALUES(10,'an old ghost town that no longer has any living community');",
			"INSERT INTO DATArec VALUES(11,'a lonely trail off into the east and a runestone carven with an arrow and the word wold');",
			"INSERT INTO DATArec VALUES(12,'a yellow marsh of moors that fens and ires');",
			"INSERT INTO DATArec VALUES(13,'a far flung coast where the western sea rages smashing against the rocks');",
			"INSERT INTO DATArec VALUES(14,'several streams come together here to form a larger river bound south');"};
	for(int x=0; x<40 && sql[x]; x++)
		rc = sqlite3_exec(db, sql[x], 0, 0, &err_msg);
	if(rc != SQLITE_OK){
		fprintf(stderr, "SQL error: %s\n", err_msg);
		sqlite3_free(err_msg);
		sqlite3_close(db);
		return 1;
	}

	sqlite3_close(db);

	return 0;
}
			

