#include "map.h"
#include "sqlite3.h"
#include <stdio.h>

int calloutputA3(void*, int, char**, char**);

int mapA3(void){

	sqlite3 *db;
	char *err_msg = 0;

	int rc = sqlite3_open("coords.db", &db);

	if( rc != SQLITE_OK) {
		fprintf(stderr, "Cannot open database: %s\n", sqlite3_errmsg(db));
		sqlite3_close(db);

		return 1;
	}
	
	const char *sql[3] = {"SELECT * FROM DATArec WHERE Id=3;",
				"SELECT * FROM TITLErec WHERE ID=1;",
				"SELECT * FROM STAGErec WHERE ID=1;"};

	rc = sqlite3_exec(db, sql[2], calloutputA3, 0, &err_msg);
	if(rc != SQLITE_OK){
		fprintf(stderr, "SQL error: %s\n", err_msg);
		sqlite3_free(err_msg);
		sqlite3_close(db);
		return 1;
	}

	sqlite3_close(db);

	return 0;
}
			
int
calloutputA3(void *NotUsed, int argc, char **argv, char **azColName) {
	
	NotUsed = 0; 

	for( int i=0; i < argc; i++ ){
		printf("%s = %s\n", azColName[i], argv[i] ? argv[i] : NULL );
	}

	printf("\n");

	return 0;
}


