#include <basics.h>
#include <magicuser.h>
#include <curses.h>
#include <string.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <new>

using namespace std;

float ran0(long*);
int studies(WINDOW*, long);
int set_spells(struct magicuser*);
int traversal(struct magicuser*, long);



int
main(int argc, char *argv[]){
	FILE *protagonist;
	WINDOW *balanceplate; /* squelch on the pinion scope */
	WINDOW *buffer;
	char esc='\E';
	bool rote;
	int ans;
	int selector=0;
	struct magicuser* player;
	long seed;

	if(argc!=3){
		cout << "usage : towersone magicuser.bin [seed]" << endl;
		return 255;
	}

	ifstream readin(argv[1], ios::in | ios::binary );

	player = new struct magicuser;

	readin.read((char *)player, sizeof(struct magicuser));

	readin.close();

	seed = atol(argv[2]);

	balanceplate = initscr();

	buffer = newwin(25, 80, 0, 0);

	rote=true;
	while(rote){
		wclear(buffer);
		ans = wgetch(balanceplate);

		switch(ans){
			case 45:
				if(selector==0)selector=2;
				else selector--;
				break;
			case 43:
				if(selector==2)selector=0;
				else selector++;
				break;
			case 10:
				if(selector==0){
					if(studies(buffer, (long)((4*ran0(&seed))+1)))
						mvwaddstr(buffer, 17, 5, "files missing");
				} else if(selector==1){
					mvwprintw(buffer, 17, 5, "preparing spells %d", selector);
				} else if(selector==2){
					mvwprintw(buffer, 17, 5, "traversal ensues %d", selector);
				}
				break;
			default:
				selector=0;
				break;
		}
		switch(selector){
			case 0:
				mvwaddstr(buffer, 10, 10, "(*) studies");
				mvwaddstr(buffer, 11, 10, "( ) prepare spells");
				mvwaddstr(buffer, 12, 10, "( ) traversal tower defense");
				break;
			case 1:
				mvwaddstr(buffer, 10, 10, "( ) studies");
				mvwaddstr(buffer, 11, 10, "(*) prepare spells");
				mvwaddstr(buffer, 12, 10, "( ) traversal tower defense");
				break;
			case 2:
				mvwaddstr(buffer, 10, 10, "( ) studies");
				mvwaddstr(buffer, 11, 10, "( ) prepare spells");
				mvwaddstr(buffer, 12, 10, "(*) traversal tower defense");
				break;
			default:
				mvwaddstr(buffer, 10, 11, "radio button selector broken.");
				break;
		}

		mvwprintw(buffer, 22, 5, "key: %d", ans);

		overwrite(buffer, balanceplate);

		wrefresh(balanceplate);
		if(ans == esc)rote=false;

	}

	delete player;

	delwin(buffer);
	delwin(balanceplate);

	return 0;
}





